//+------------------------------------------------------------------+
//|                                      HistoricalPWAPLogChart.mq4 |
//|                            Copyright 2007-2017, FinanceWave.com |
//|                              http://www.facebook.com/FinanceWave |
//|                                                     @FinanceWave |
//|                                       http://www.financewave.com |
//+------------------------------------------------------------------+
#property copyright   "Copyright 2007-2017, FinanceWave.com"
#property link        "http://www.financewave.com"
#property description "HistoricalPWAPLogChart"

#property indicator_separate_window
#property indicator_buffers 16
#property indicator_color13 Gold
#property indicator_color14 Gold
#property indicator_color15 Red
#property indicator_color16 DeepSkyBlue

extern color  Up   = C'0,128,0';
extern color  Down   = C'255,0,0';
extern color  Doji   = C'255,255,0';

color bg;
//--- indicator buffers
double         GREEN_HIGH[];
double         GREEN_OPEN[];
double         GREEN_CLOSE[];
double         GREEN_LOW[];
double         RED_HIGH[];
double         RED_OPEN[];
double         RED_CLOSE[];
double         RED_LOW[];
double         YELLOW_HIGH[];
double         YELLOW_OPEN[];
double         YELLOW_CLOSE[];
double         YELLOW_LOW[];

//--- buffers
double Buffer[];
double Buffer2[];
double Buffer3[];
double Buffer4[];

double pwap;
extern double DP = 2;
double error=0;
double errorsum=0;
int bars=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   IndicatorShortName("HistoricalPWAPLogChart");

   bg=(color)ChartGetInteger(ChartID(),CHART_COLOR_BACKGROUND);
//--- indicator buffers mapping
   SetIndexBuffer(0,GREEN_CLOSE);SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,3,Up);
   SetIndexBuffer(1,GREEN_OPEN);SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,3,bg);
   SetIndexBuffer(2,GREEN_HIGH);SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,1,Up);
   SetIndexBuffer(3,GREEN_LOW);SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,1,bg);
   SetIndexBuffer(4,RED_OPEN);SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID,3,Down);
   SetIndexBuffer(5,RED_CLOSE);SetIndexStyle(5,DRAW_HISTOGRAM,STYLE_SOLID,3,bg);
   SetIndexBuffer(6,RED_HIGH);SetIndexStyle(6,DRAW_HISTOGRAM,STYLE_SOLID,1,Down);
   SetIndexBuffer(7,RED_LOW);SetIndexStyle(7,DRAW_HISTOGRAM,STYLE_SOLID,1,bg);
   SetIndexBuffer(8,YELLOW_OPEN);SetIndexStyle(8,DRAW_HISTOGRAM,STYLE_SOLID,3,Doji);
   SetIndexBuffer(9,YELLOW_CLOSE);SetIndexStyle(9,DRAW_HISTOGRAM,STYLE_SOLID,3,bg);
   SetIndexBuffer(10,YELLOW_HIGH);SetIndexStyle(10,DRAW_HISTOGRAM,STYLE_SOLID,1,Doji);
   SetIndexBuffer(11,YELLOW_LOW);SetIndexStyle(11,DRAW_HISTOGRAM,STYLE_SOLID,1,bg);
   
   SetIndexStyle(12,DRAW_NONE);
   SetIndexBuffer(12,Buffer);
   SetIndexStyle(13,DRAW_LINE);
   SetIndexBuffer(13,Buffer2);
   SetIndexStyle(14,DRAW_LINE);
   SetIndexBuffer(14,Buffer3);
   SetIndexStyle(15,DRAW_LINE);
   SetIndexBuffer(15,Buffer4);

   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);   
   SetIndexLabel(3,NULL);      
   SetIndexLabel(4,NULL);      
   SetIndexLabel(5,NULL);      
   SetIndexLabel(6,NULL);      
   SetIndexLabel(7,NULL);      
   SetIndexLabel(8,NULL);      
   SetIndexLabel(9,NULL);      
   SetIndexLabel(10,NULL);      
   SetIndexLabel(11,NULL);      
   SetIndexLabel(12,NULL);      
   SetIndexLabel(13,NULL);      
   SetIndexLabel(14,NULL);      
   SetIndexLabel(15,NULL);      

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
   int start()

  {
   double OPEN,HIGH,LOW,CLOSE;

   for(int i=Bars-1;i>=0;i--) 
   {
      GREEN_OPEN[i]=GREEN_HIGH[i]=GREEN_LOW[i]=GREEN_CLOSE[i]=EMPTY_VALUE;
      RED_OPEN[i]=RED_HIGH[i]=RED_LOW[i]=RED_CLOSE[i]=EMPTY_VALUE;
      YELLOW_OPEN[i]=YELLOW_HIGH[i]=YELLOW_LOW[i]=YELLOW_CLOSE[i]=EMPTY_VALUE;
   }

   for(i=Bars-1;i>=0;i--) 
   {
     {

      OPEN=MathLog(iOpen(NULL,0,i));
      CLOSE=MathLog(iClose(NULL,0,i));
      HIGH=MathLog(iHigh(NULL,0,i));
      LOW=MathLog(iLow(NULL,0,i));

      if(CLOSE>OPEN)
         {
         GREEN_OPEN[i]=OPEN;
         GREEN_HIGH[i]=HIGH;
         GREEN_LOW[i]=LOW;
         GREEN_CLOSE[i]=CLOSE;
         }
      else if(CLOSE<OPEN) 
        {
         RED_OPEN[i]=OPEN;
         RED_HIGH[i]=HIGH;
         RED_LOW[i]=LOW;
         RED_CLOSE[i]=CLOSE;
        }
      else if(CLOSE==OPEN)
        {YELLOW_OPEN[i]=OPEN;
         YELLOW_HIGH[i]=HIGH;
         YELLOW_LOW[i]=LOW;
         YELLOW_CLOSE[i]=CLOSE;
        }
      }
   }

if(Bars-1>bars)
{
for(i = Bars-1-bars; i>0; i--)
{
Buffer[i]=(MathLog(iOpen(NULL,0,i))+MathLog(iHigh(NULL,0,i))+MathLog(iLow(NULL,0,i))+MathLog(iClose(NULL,0,i)) )/4;
Buffer2[i]=iMAOnArray(Buffer,0,Bars-i,0,MODE_SMA,i);

error=MathMax(Buffer[i]-Buffer2[i],Buffer2[i]-Buffer[i]);
errorsum=errorsum+error;

Buffer3[i]=Buffer2[i]-DP*(errorsum/(Bars-i));
Buffer4[i]=Buffer2[i]+DP*(errorsum/(Bars-i));
}
bars=Bars-1;
}

ObjectCreate( 0,"LINE1",OBJ_HLINE,ChartWindowFind(0,"HistoricalPWAPLogChart"),Time[0],MathLog(iClose(NULL,0,0)));
ObjectSet   ("LINE1", OBJPROP_PRICE1,MathLog(iClose(NULL,0,0)) );
ObjectSet   ("LINE1",OBJPROP_COLOR,Gray);
ObjectSet   ("LINE1",OBJPROP_WIDTH,1);

   return(0);
  }
//+------------------------------------------------------------------+